#include <signal.h>
#include <stdint.h>
#include "Assertion.hpp"
#include "GlobalSettings.hpp"
#include "SolverFactory.hpp"
#include "AtomicTypes.hpp"
#include "IFStream.hpp"
#include "SolverTrooper.hpp"
#include "Logging.hpp"
#include <omp.h>
#include <iostream>
#include "OMPRun.hpp"

#ifdef LOGGING_ENABLED
std::vector<std::ofstream*> Logging::outs;
std::vector<uint64_t> Logging::counts;
#endif

const double Satistics::WTIME_START = omp_get_wtime();

/**
 * Some checks
 */

bool check_defines(){

	std::cerr << "Assertions are evaluated and wordsize is " << sizeof(void*) << endl ;
    return
    //sizeof(void*)           ==      32/8                &&
    sizeof(int32_t)         ==      32/8                &&
    sizeof(int64_t)         ==      64/8                &&
    sizeof(uint32_t)        ==      32/8                &&
    sizeof(uint64_t)        ==      64/8                &&
    sizeof(double)          ==      64/8                &&
    sizeof(float)           ==      32/8                &&
    sizeof(Literal)         ==      sizeof(uint32_t)    &&
    sizeof(Variable)        ==      sizeof(uint32_t)    &&
    sizeof(float)           ==      sizeof(uint32_t)    &&
    ((int)false)            ==      0                   &&
    ((int)true)             ==      1;
};




int main(int argc, char** argv){
    asrt(check_defines()); sanity((fprintf(stderr,"Sanity Checks are evaluated\n"),true));


    GlobalSettings global_settings;
    if(!global_settings.read(argc,argv)){
    	global_settings.printUsage();
        return EXIT_FAILURE;
    }

    return ompRun(global_settings);
}




const char*  sapperlot_cpp_version(){return "$Revision: 1.1 $";}


